function [Kmat Sigma B H] = ...
    build_matrices(K_vec, Sigma_vec, B_vec, errorSDs)
% BUILD_MATRICES unpacks parameters of the model into the matrices 
% and vectors of the model.  

%
% Greg Duffee
% June 2011
%

Kmat = vec_inverse(K_vec); 
numfactors = size(Kmat, 1); 

Sigma = zeros(numfactors, numfactors); 
index = 0; 
for i = 1:numfactors
  for j = 1:i
    index = index + 1; 
    Sigma(i,j) = Sigma_vec(index);
  end
end

numObserved = length(B_vec)/numfactors;

B = reshape(B_vec, numObserved, numfactors);

H = diag((errorSDs/100.0) .^2);  % remember that the inputs are in
                        % percentage points 
return
