function [funval loglikes filtered_values errors] = ...
    kalman_only_loglike(freeparams, allparams, free_index, ...
                        observedData, numFactors, tolerance)
% KALMAN_ONLY_LOGLIKE returns the (negative of the) Kalman filter
% log-likelihood.  This is used for standard ML estimation.  

%
% Greg Duffee
% June 2011
%

[T numObserved] = size(observedData); 

paramvec = poke_freeparams(freeparams, allparams, free_index); 


[mu K_vec Sigma_vec A B_vec errorSDs] = ...
    unpack_allparams(numFactors, numObserved, paramvec);

[Kmat Sigma B H] = ...
    build_matrices(K_vec, Sigma_vec, B_vec, errorSDs); 

[errors loglikes filtered_values cond_vars contemp_vars ...
         normSqrErrors eigFs] = ...
    kalman_recursion_noderiv(observedData, mu, Kmat, Sigma, H, A, B, ...
                             tolerance);
funval = -sum(loglikes);

return

