function [paramvec indexvec] = pack_allparams( ...
    mu_vals, k_vals, S_vals, A_vals, B_vals, errorSD_vals, ...
    mu_flag, k_flag, S_flag, A_flag, B_flag, ...
    errorSD_flag)
% PACK_ALLPARAMS is a routine that packs parameters of the model into
% a single vector.  It also packs the flags that indicate whether a parameter
% is free.

%
% Greg Duffee
% June 2011
%

paramvec = [mu_vals; k_vals; ...
            S_vals; A_vals; B_vals; errorSD_vals];
indexvec = [mu_flag; k_flag; ...
            S_flag; A_flag; B_flag; errorSD_flag];

return
