function [observedData] = ...
    read_data(yielddatafile, macrodatafile, numbonds, usedBondIdx, ...
              numMacro, usedMacroIdx, firstobs, lastobs)
%
% READ_DATA is a routine that reads the data for the estimation problem. 

% Greg Duffee
% October 2005, revised Jan 2006, June 2006, August 2006, June 2011
%

%
% the yields 
% 

if (length(usedBondIdx) > 0) 

  formatstring = '%f';
  for i = 2:numbonds
    formatstring = [formatstring ' %f'];
  end
  fid = fopen(yielddatafile, 'rt');
  output = textscan(fid, formatstring, -1); 
  yielddata = []; 
  for i = 1:numbonds
    yielddata = [yielddata output{i}];
  end
  fclose(fid); 

else
  yielddata = []; 
end


%
% macro data
% 

if (length(usedMacroIdx) > 0) 
  
  formatstring = '%f';
  for i = 2:numMacro
    formatstring = [formatstring ' %f'];
  end
  fid = fopen(macrodatafile, 'rt');
  output = textscan(fid, formatstring, -1); 
  macrodata = []; 
  for i = 1:numMacro
    macrodata = [macrodata output{i}];
  end
  fclose(fid); 

else
  
  macrodata = [];
end

  
%
% pull out the desired series.
%

if (length(usedBondIdx) > 0 )
  
  observedData = yielddata(firstobs:lastobs,usedBondIdx);
  
  if (length(usedMacroIdx) > 0) 
  
  observedData = [observedData  macrodata(firstobs:lastobs, ...
                                          usedMacroIdx)];
  end
  
else

  observedData = macrodata(firstobs:lastobs, usedMacroIdx);

end

return



