function [yielddatafile numbonds numUsedBonds usedBondIdx ...
          macrodatafile numMacro numUsedMacro usedMacroIdx ...
          numfactors firstobs lastobs ...
          use_ols_start olsStartIdx ...
          numloops numSmallLoops numsimplex numderiv ...
          mu_names mu_flag mu_initialval mu_rand_stddev ...
          k_names k_flag k_initialval k_rand_stddev ...
          S_names S_flag S_initialval S_rand_stddev ...
          A_names A_flag A_initialval A_rand_stddev ...
          B_names B_flag B_initialval B_rand_stddev ...
          errorSD_names errorSD_flag errorSD_initialval errorSD_rand_stddev ...
          ] = read_input(inputfile)
%
% READ_INPUT(inputfile) is a routine that reads the setup of the
% estimation problem from the file 'inputfile'.

% Greg Duffee
% June 2011
%

%
% open the input file
%

fid = fopen(inputfile, 'rt');

%
% read the name of the file with the yields
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 14) & (tmp(1:15) == 'BOND YIELD DATA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
yielddatafile = char(output{1});

%
% read the number of bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF BOND YIELDS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numbonds = output{1} ;

%
% read the number of used bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF USED BOND Y'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numUsedBonds = output{1} ;

if (numUsedBonds > 0) 

  %
  % read the indexes of used bond yields 
  %
  
  frewind(fid); 
  foundline = 0; 
  while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'INDEXES OF USED BOND '))
      foundline = 1; 
    end
  end
  output = textscan(fid, '%d', double(numUsedBonds)); 
  usedBondIdx = output{1};
  
else
  
  usedBondIdx = [];
end

  
%
% read the name of the file with the macro data
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 14) & (tmp(1:15) == 'MACRO DATA FILE'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
macrodatafile = char(output{1});

%
% read the number of macro variables
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 19) & (tmp(1:20) == 'NUMBER OF MACRO VARS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numMacro = output{1} ;

%
% read the number of used macro vars 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF USED MACRO '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numUsedMacro = output{1} ;

if (numUsedMacro > 0) 

  %
  % read the indexes of used macro vars
  %
  
  frewind(fid); 
  foundline = 0; 
  while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'INDEXES OF USED MACRO'))
      foundline = 1; 
    end
  end
  output = textscan(fid, '%d', double(numUsedMacro)); 
  usedMacroIdx = output{1};
  
else
  
  usedMacroIdx = [];
end

  
%
% read the number of common factors
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 15) & (tmp(1:16) == 'NUMBER OF COMMON'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numfactors = output{1} ;

%
% read the index of the first used observation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'INDEX OF FIRS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
firstobs = output{1};

%
% read the index of the last used observation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'INDEX OF LAST'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
lastobs = output{1};

%
% read the flag for using OLS starting values 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'USE OLS START'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
use_ols_start = output{1};

%
% read the indexes of OLS start
%

olsStartIdx = zeros(numfactors, 1); 

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'DATA INDEXES FOR OLS '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', double(numfactors)); 
olsStartIdx = output{1};

%
% read the number of loops used in numerical estimation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF LOO'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numloops = output{1};

%
% read the number of small loops used in numerical estimation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF SMA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numSmallLoops = output{1};

%
% read the number of simplex calls per loop
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF SIM'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numsimplex = output{1};

%
% read the number of derivative-based min calls per loop
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF DER'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numderiv = output{1};

%
% READING INFORMATION ABOUT PARAMETERS

%
% mu 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
  output = textscan(fid, '%[^\n]', 1); 
  tmp = char(output{1}); 
  if ((length(tmp) > 19) & (tmp(1:20) == 'MU VECTOR (must be n'))
    foundline = 1; 
  end
end
output = textscan(fid, '%s %d %f %f', double(numfactors)); 
mu_names = char(output{1}); 
mu_flag = output{2};
mu_initialval = output{3}; 
mu_rand_stddev = output{4};

%
% K matrix
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 17) & (tmp(1:18) == 'K MATRIX  (must be'))
        foundline = 1; 
    end
end
numlines = double(numfactors^2); 
output = textscan(fid, '%s %d %f %f', numlines); 
k_names = char(output{1}); 
k_flag = output{2};
k_initialval = output{3}; 
k_rand_stddev = output{4};

%
% common factor sigma matrix
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 18) & (tmp(1:19) == 'COMMON FACTOR SIGMA'))
        foundline = 1; 
    end
end
numlines = double(numfactors*(1+numfactors)/2); 
output = textscan(fid, '%s %d %f %f', numlines); 
S_names = char(output{1}); 
S_flag = output{2};
S_initialval = output{3}; 
S_rand_stddev = output{4};

%
% A vector 
%

numObserved = numUsedBonds + numUsedMacro; 

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'A VECTOR (must eq'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(numObserved)); 
A_names = char(output{1}); 
A_flag = output{2};
A_initialval = output{3}; 
A_rand_stddev = output{4};

%
% B matrix 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'B MATRIX (must eq'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(numObserved*numfactors)); 
B_names = char(output{1}); 
B_flag = output{2};
B_initialval = output{3}; 
B_rand_stddev = output{4};

%
% Standard dev of measurement error
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'MEASUREMENT ERROR'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(numObserved)); 
errorSD_names = char(output{1}); 
errorSD_flag = output{2};
errorSD_initialval = output{3}; 
errorSD_rand_stddev = output{4};

fclose(fid); 

end
