function [mu, K_vec, Sigma_vec, A, B_vec, errorSDs] = ...
    unpack_allparams(numFactors, numObserved, paramvec)

%
% UNPACK_ALLPARAMS unpacks the parameter vector into individual vectors.
% Another routine further unpacks the individual vectors into matrices.
%

%
% Greg Duffee
% June 2011
%

start_index = 1;
end_index = start_index + numFactors - 1; 
mu = paramvec(start_index:end_index);

start_index = end_index + 1;
end_index = start_index + numFactors^2 - 1;
K_vec = paramvec(start_index:end_index); 

start_index = end_index + 1;
end_index = start_index + (numFactors*(numFactors+1))/2 - 1; 
Sigma_vec = paramvec(start_index:end_index); 

start_index = end_index + 1; 
end_index = start_index + numObserved - 1;
A = paramvec(start_index:end_index); 

start_index = end_index + 1; 
end_index = start_index + numFactors*numObserved - 1;
B_vec = paramvec(start_index:end_index); 

start_index = end_index + 1;
end_index = start_index + numObserved - 1; 
errorSDs = paramvec(start_index:end_index); 

return
