function [A B H] = ...
    build_matrices(delta0, delta1, Avec, Bvec, errorSDs)
% BUILD_MATRICES unpacks parameters of the model into the matrices 
% and vectors of the model.  

%
% Greg Duffee
% June 2011
%

numObserved = length(errorSDs);

numOtherBonds = numObserved - 3; 

A_f = [0;0];
B_fMat = [0 1 0 0; 1 0 0 0];

if (numOtherBonds > 0)
  Bother = reshape(Bvec, [], 4);
end

A = [delta0; Avec; A_f];

if (numOtherBonds > 0)
  B = [delta1'; Bother; B_fMat];
else
  B = [delta1'; B_fMat];
end

H = diag((errorSDs/100.0) .^2);  % remember that the inputs are in
                        % percentage points 
return
