function [paramvec indexvec] = pack_allparams( ...
    means_vals, bcm_vals, stddev_vals, A_vals, ...
    B_vals, errorSD_vals, ...
    means_flag, bcm_flag, stddev_flag, A_flag, B_flag, errorSD_flag)
% PACK_ALLPARAMS is a routine that packs parameters of the model into
% a single vector.  It also packs the flags that indicate whether a parameter
% is free.

%
% Greg Duffee
% June 2011
%

paramvec = [means_vals; bcm_vals; ...
            stddev_vals; A_vals; B_vals; errorSD_vals];
indexvec = [means_flag; bcm_flag; stddev_flag; A_flag; ...
            B_flag; errorSD_flag];

return
