function [yielddatafile numbonds numUsedBonds usedBondIdx ...
          macrodatafile numMacro usedMacroIdx ...
          firstobs lastobs  ...
          numloops numSmallLoops numsimplex numderiv ...
          means_names means_flag means_initialval means_rand_stddev ...
          bcm_names bcm_flag bcm_initialval bcm_rand_stddev ...
          stddev_names stddev_flag stddev_initialval stddev_rand_stddev ...
          A_names A_flag A_initialval A_rand_stddev ...
          B_names B_flag B_initialval B_rand_stddev ...
          errorSD_names errorSD_flag errorSD_initialval errorSD_rand_stddev ...
          ] = read_input(inputfile)
%
% READ_INPUT(inputfile) is a routine that reads the setup of the
% estimation problem from the file 'inputfile'.

% Greg Duffee
% June 2011
%

%
% open the input file
%

fid = fopen(inputfile, 'rt');

%
% read the name of the file with the yields
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 14) & (tmp(1:15) == 'BOND YIELD DATA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
yielddatafile = char(output{1});

%
% read the number of bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF BOND YIELDS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numbonds = output{1} ;

%
% read the number of used bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF USED BOND Y'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numUsedBonds = output{1} ;

%
% read the indexes of used bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'INDEXES OF USED BOND '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', double(numUsedBonds)); 
usedBondIdx = output{1};

%
% read the name of the file with the macro data
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 14) & (tmp(1:15) == 'MACRO DATA FILE'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
macrodatafile = char(output{1});

%
% read the number of macro variables
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 19) & (tmp(1:20) == 'NUMBER OF MACRO VARS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numMacro = output{1} ;

numUsedMacro = 2; 

%
% read the indexes of used macro vars
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'INDEXES OF USED MACRO'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', double(numUsedMacro)); 
usedMacroIdx = output{1};

%
% read the index of the first used observation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'INDEX OF FIRS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
firstobs = output{1};

%
% read the index of the last used observation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'INDEX OF LAST'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
lastobs = output{1};

%
% read the number of loops used in numerical estimation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF LOO'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numloops = output{1};

%
% read the number of small loops used in numerical estimation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF SMA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numSmallLoops = output{1};

%
% read the number of simplex calls per loop
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF SIM'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numsimplex = output{1};

%
% read the number of derivative-based min calls per loop
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF DER'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numderiv = output{1};

%
% READING INFORMATION ABOUT PARAMETERS

%
% means 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
  output = textscan(fid, '%[^\n]', 1); 
  tmp = char(output{1}); 
  if ((length(tmp) > 10) & (tmp(1:11) == 'MEAN VECTOR'))
    foundline = 1; 
  end
end
output = textscan(fid, '%s %d %f %f', 3); 
means_names = char(output{1}); 
means_flag = output{2};
means_initialval = output{3}; 
means_rand_stddev = output{4};

%
% Bekaert, Cho, Moreno params
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 9) & (tmp(1:10) == 'BCM PARAMS'))
        foundline = 1; 
    end
end
numlines = 9;
output = textscan(fid, '%s %d %f %f', numlines); 
bcm_names = char(output{1}); 
bcm_flag = output{2};
bcm_initialval = output{3}; 
bcm_rand_stddev = output{4};

%
% Std devs of shocks
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 17) & (tmp(1:18) == 'STD DEVS OF SHOCKS'))
        foundline = 1; 
    end
end
numlines = 4;
output = textscan(fid, '%s %d %f %f', numlines); 
stddev_names = char(output{1}); 
stddev_flag = output{2};
stddev_initialval = output{3}; 
stddev_rand_stddev = output{4};

%
% A vector
%

if (numUsedBonds > 1) 
  frewind(fid); 
  foundline = 0; 
  while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 7) & (tmp(1:8) == 'A VECTOR'))
      foundline = 1; 
    end
  end
  output = textscan(fid, '%s %d %f %f', double(numUsedBonds - 1)); 
  A_names = char(output{1}); 
  A_flag = output{2};
  A_initialval = output{3}; 
  A_rand_stddev = output{4};

  %
  % B matrix 
  %
  
  frewind(fid); 
  foundline = 0; 
  while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 7) & (tmp(1:8) == 'B MATRIX'))
      foundline = 1; 
    end
  end
  
  output = textscan(fid, '%s %d %f %f', double(4*(numUsedBonds-1))); 
  B_names = char(output{1}); 
  B_flag = output{2};
  B_initialval = output{3}; 
  B_rand_stddev = output{4};
else
  A_names = [];
  A_flag = [];
  A_initialval = [];
  A_rand_stddev = [];
  B_names = [];
  B_flag = [];
  B_initialval = [];
  B_rand_stddev = []; 
end

%
% Standard dev of measurement error
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'MEASUREMENT ERROR'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(3+numUsedBonds)); 
errorSD_names = char(output{1}); 
errorSD_flag = output{2};
errorSD_initialval = output{3}; 
errorSD_rand_stddev = output{4};

fclose(fid); 

end
