function [mu, bcm, stddevs, Avec, Bvec, errorSDs] = ...
    unpack_allparams(paramvec, numbonds)

%
% UNPACK_ALLPARAMS unpacks the parameter vector into individual vectors.
% Another routine further unpacks the individual vectors into matrices.
%

%
% Greg Duffee
% June 2011
%

start_index = 1;
end_index = start_index + 3 - 1; 
mu = paramvec(start_index:end_index);

start_index = end_index + 1;
end_index = start_index + 9 - 1;
bcm = paramvec(start_index:end_index); 

start_index = end_index + 1;
end_index = start_index + 4 - 1; 
stddevs = paramvec(start_index:end_index); 

if (numbonds > 1) 
  start_index = end_index + 1; 
  end_index = start_index + (numbonds - 1) - 1;
  Avec = paramvec(start_index:end_index); 

  start_index = end_index + 1; 
  end_index = start_index + 4*(numbonds - 1) - 1;
  Bvec = paramvec(start_index:end_index); 
else
  Avec = [];
  Bvec = []; 
end

start_index = end_index + 1;
end_index = start_index + (2+numbonds) - 1; 
errorSDs = paramvec(start_index:end_index); 

  
return
