function [kMatStar SigmaMatStar B_fMat ...
          kEquivMatLatent maxAbsEquivEig H] = ...
    build_matrices(kStar, SigmaStar, B_f, eigs, errorSDs)
% BUILD_MATRICES unpacks some of the vectorized parameters of the
% model into matrices.

%
% Greg Duffee
% June 2011
%

kMatStar = vec_inverse(kStar); 
numfactors = size(kMatStar,1);

SigmaMatStar = zeros(numfactors, numfactors); 
index = 0; 
for i = 1:numfactors
  for j = 1:i
    index = index + 1; 
    SigmaMatStar(i,j) = SigmaStar(index);
  end
end

% transform SigmaMatStar so diagonal elements are all nonnegative.

for i = 1:numfactors
  SigmaMatStar(:,i) = sign(SigmaMatStar(i,i))*SigmaMatStar(:,i);
end

B_fMat = reshape(B_f, [], numfactors); 

[kEquivMatLatent maxAbsEquivEig] = buildKequivLatent(eigs, [], []);

H = diag((errorSDs/100.0) .^2);  % remember that the inputs are in
                        % percentage points 
return
