function Avec = createBigA(rho0, mu, Sigma, Bmat)
% Create entire set of A functions for maturities from one to
% maxMat.   Requires Bmatrix as an input.  
%
% Greg Duffee
% September 2009
%

n = size(Sigma, 1); 
maxMat = size(Bmat, 1); 

Avec = zeros(maxMat, 1); 
H = Sigma*Sigma'; 

% thisA, thisB, newA, newB are for log prices.  They are
% transformed when saving to the vector and matrix.  

thisA = 0; 
thisB = zeros(n, 1); 
for i = 1:maxMat
  newA = thisA + mu'*thisB + 0.5*(thisB'*H*thisB) - rho0; 
  Avec(i) = -newA/i;
  thisA = newA;
  thisB = -i*Bmat(i,:)'; 
end
  
return

