function [paramvec indexvec] = pack_allparams( ...
    mu_vals, K_vals, S_vals, rinfty_val, ...
    eig_vals, A_vals, B_vals, errorSD_vals, mu_flag, ...
    K_flag, S_flag, rinfty_flag, eig_flag, ...
    A_flag, B_flag, errorSD_flag)
% PACK_ALLPARAMS is a routine that packs parameters of the model into
% a single vector.  It also packs the flags that indicate whether a parameter
% is free.

%
% Greg Duffee
% September 2009
%

paramvec = [mu_vals; K_vals; S_vals; rinfty_val; eig_vals; ...
            A_vals; B_vals; errorSD_vals];
indexvec = [mu_flag; K_flag; S_flag; rinfty_flag; eig_flag; ...
            A_flag; B_flag; errorSD_flag];

return
