function [observedData maturities] = ...
    read_data(yielddatafile, maturitydatafile, ...
              macrodatafile, numbonds, usedBondIdx, ...
              numMacro, usedMacroIdx, firstobs, lastobs)
%
% READ_DATA is a routine that reads the data for the estimation problem. 

% Greg Duffee
% October 2005, revised Jan 2006, June 2006, August 2006, June 2011
%

%
% the yields 
% 

formatstring = '%f';
for i = 2:numbonds
    formatstring = [formatstring ' %f'];
end
fid = fopen(yielddatafile, 'rt');
output = textscan(fid, formatstring, -1); 
yielddata = []; 
for i = 1:numbonds
    yielddata = [yielddata output{i}];
end
fclose(fid); 


%
% maturities  
% 

fid = fopen(maturitydatafile, 'rt');
output = textscan(fid, '%f', -1); 
maturities = output{1};
fclose(fid); 

%
% macro data
% 

formatstring = '%f';
for i = 2:numMacro
    formatstring = [formatstring ' %f'];
end
fid = fopen(macrodatafile, 'rt');
output = textscan(fid, formatstring, -1); 
macrodata = []; 
for i = 1:numMacro
    macrodata = [macrodata output{i}];
end
fclose(fid); 

%
% pull out the desired series.
%

observedData = [yielddata(firstobs:lastobs,usedBondIdx) ...
                macrodata(firstobs:lastobs,usedMacroIdx)];

maturities = maturities(usedBondIdx);

end

