function [yielddatafile maturitydatafile ...
          numbonds numUsedBonds usedBondIdx ...
          macrodatafile numMacro numUsedMacro usedMacroIdx ...
          numfactors firstobs lastobs ...
          macroLoadings ... 
          use_ols_start use_pc factor_indexes ...
          numloops numSmallLoops numsimplex numderiv ...
          muStar_names muStar_flag muStar_initialval muStar_rand_stddev ...
          kStar_names kStar_flag kStar_initialval kStar_rand_stddev ...
          SigmaStar_names SigmaStar_flag SigmaStar_initialval ...
          SigmaStar_rand_stddev ...
          rinfty_name rinfty_flag rinfty_initialval rinfty_rand_stddev ...
          eig_names eig_flag eig_initialval eig_rand_stddev ...
          A_f_names A_f_flag A_f_initialval A_f_rand_stddev ...
          B_f_names B_f_flag B_f_initialval B_f_rand_stddev ...
          errorSD_names errorSD_flag errorSD_initialval errorSD_rand_stddev ...
          ] = read_input(inputfile)
%
% READ_INPUT(inputfile) is a routine that reads the setup of the
% estimation problem from the file 'inputfile'.

% Greg Duffee
% June 2011
%

%
% open the input file
%

fid = fopen(inputfile, 'rt');

%
% read the name of the file with the yields
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 14) & (tmp(1:15) == 'BOND YIELD DATA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
yielddatafile = char(output{1});

%
% read the name of the file with the maturities 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'MATURITY DATA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
maturitydatafile = char(output{1});


%
% read the number of bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF BOND YIELDS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numbonds = output{1} ;

%
% read the number of used bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF USED BOND Y'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numUsedBonds = output{1} ;

%
% read the indexes of used bond yields 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'INDEXES OF USED BOND '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', double(numUsedBonds)); 
usedBondIdx = output{1};

%
% read the name of the file with the macro data
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 14) & (tmp(1:15) == 'MACRO DATA FILE'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s', 1); 
macrodatafile = char(output{1});

%
% read the number of macro variables
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 19) & (tmp(1:20) == 'NUMBER OF MACRO VARS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numMacro = output{1} ;

%
% read the number of used macro vars 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'NUMBER OF USED MACRO '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numUsedMacro = output{1} ;

%
% read the indexes of used macro vars
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 20) & (tmp(1:21) == 'INDEXES OF USED MACRO'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', double(numUsedMacro)); 
usedMacroIdx = output{1};

%
% read the number of common factors
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 15) & (tmp(1:16) == 'NUMBER OF COMMON'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numfactors = output{1} ;

%
% read the index of the first used observation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'INDEX OF FIRS'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
firstobs = output{1};

%
% read the index of the last used observation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'INDEX OF LAST'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
lastobs = output{1};

%
% read the flag for whether the macro loadings are for the latent
% factor rotation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 17) & (tmp(1:18) == 'MACRO LOADINGS ARE'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
macroLoadings = output{1};

%
% read the flag for using OLS starting values 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'USE OLS START'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
use_ols_start = output{1};

%
% Are PCs used as factors?
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 13) & (tmp(1:14) == 'USE PRINCIPAL '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
use_pc = output{1};

%
% read the indexes of observations used as factors
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 19) & (tmp(1:20) == 'INDEXES OF OBS USED '))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', numfactors); 
factor_indexes = output{1};

%
% read the number of loops used in numerical estimation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF LOO'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numloops = output{1};

%
% read the number of small loops used in numerical estimation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF SMA'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numSmallLoops = output{1};

%
% read the number of simplex calls per loop
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF SIM'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numsimplex = output{1};

%
% read the number of derivative-based min calls per loop
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 12) & (tmp(1:13) == 'NUMBER OF DER'))
        foundline = 1; 
    end
end
output = textscan(fid, '%d', 1); 
numderiv = output{1};

%
% READING INFORMATION ABOUT PARAMETERS

%
% constant in physical dynamics, observable rotation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
  output = textscan(fid, '%[^\n]', 1); 
  tmp = char(output{1}); 
  if ((length(tmp) > 19) & (tmp(1:20) == 'CONSTANT IN PHYSICAL'))
    foundline = 1; 
  end
end
output = textscan(fid, '%s %d %f %f', double(numfactors)); 
muStar_names = char(output{1}); 
muStar_flag = output{2};
muStar_initialval = output{3}; 
muStar_rand_stddev = output{4};

%
% physical K matrix, observable rotation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 17) & (tmp(1:18) == 'PHYSICAL FEEDBACK '))
        foundline = 1; 
    end
end
numlines = double(numfactors^2); 
output = textscan(fid, '%s %d %f %f', numlines); 
kStar_names = char(output{1}); 
kStar_flag = output{2};
kStar_initialval = output{3}; 
kStar_rand_stddev = output{4};

%
% common factor sigma matrix, observable rotation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 18) & (tmp(1:19) == 'COMMON FACTOR SIGMA'))
        foundline = 1; 
    end
end
numlines = double(numfactors*(1+numfactors)/2); 
output = textscan(fid, '%s %d %f %f', numlines); 
SigmaStar_names = char(output{1}); 
SigmaStar_flag = output{2};
SigmaStar_initialval = output{3}; 
SigmaStar_rand_stddev = output{4};

%
% constant short rate factor, latent rotation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'CONSTANT IN SHORT'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', 1); 
rinfty_name = char(output{1}); 
rinfty_flag = output{2};
rinfty_initialval = output{3}; 
rinfty_rand_stddev = output{4};

%
% eigenvalues of K^q matrix 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
  output = textscan(fid, '%[^\n]', 1); 
  tmp = char(output{1}); 
  if ((length(tmp) > 21) & (tmp(1:22) == 'REAL SINGLE EIGENVALUE'))
    foundline = 1; 
  end
end
numlines = double(numfactors); 
output = textscan(fid, '%s %d %f %f', numlines); 
eig_names = char(output{1}); 
eig_flag = output{2};
eig_initialval = output{3}; 
eig_rand_stddev = output{4};

%
% A_f vector, latent rotation
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 23) & (tmp(1:24) == 'CONSTANT TERMS FOR MACRO'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(numUsedMacro)); 
A_f_names = char(output{1}); 
A_f_flag = output{2};
A_f_initialval = output{3}; 
A_f_rand_stddev = output{4};

%
% B_f matrix, latent rotation 
%

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'LOADING TERMS FOR'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(numUsedMacro*numfactors)); 
B_f_names = char(output{1}); 
B_f_flag = output{2};
B_f_initialval = output{3}; 
B_f_rand_stddev = output{4};

%
% Standard dev of measurement error
%

numObserved = numUsedBonds + numUsedMacro; 

frewind(fid); 
foundline = 0; 
while foundline == 0
    output = textscan(fid, '%[^\n]', 1); 
    tmp = char(output{1}); 
    if ((length(tmp) > 16) & (tmp(1:17) == 'MEASUREMENT ERROR'))
        foundline = 1; 
    end
end
output = textscan(fid, '%s %d %f %f', double(numObserved)); 
errorSD_names = char(output{1}); 
errorSD_flag = output{2};
errorSD_initialval = output{3}; 
errorSD_rand_stddev = output{4};

fclose(fid); 

end
