function [muStar, kStar, SigmaStar, rinfty, eig, A_f, B_f, errorSD] = ...
    unpack_allparams(numfactors, numUsedMacro, paramvec)

%
% UNPACK_ALLPARAMS unpacks the parameter vector into individual vectors.
% Another routine further unpacks the individual vectors into matrices.
%

%
% Greg Duffee
% June 2011
%

numparams = length(paramvec); 

start_index = 1;
end_index = start_index + numfactors - 1; 
muStar = paramvec(start_index:end_index);

start_index = end_index + 1;
end_index = start_index + numfactors^2 - 1;
kStar = paramvec(start_index:end_index); 

start_index = end_index + 1;
end_index = start_index + (numfactors*(numfactors+1))/2 - 1; 
SigmaStar = paramvec(start_index:end_index); 

start_index = end_index + 1; 
end_index = start_index + 1 - 1;
rinfty = paramvec(start_index:end_index); 

start_index = end_index + 1; 
end_index = start_index + numfactors - 1; 
eig = paramvec(start_index:end_index);

start_index = end_index + 1; 
end_index = start_index + numUsedMacro - 1; 
A_f = paramvec(start_index:end_index);

start_index = end_index + 1; 
end_index = start_index + numfactors*numUsedMacro - 1; 
B_f = paramvec(start_index:end_index);

start_index = end_index + 1; 
errorSD = paramvec(start_index:end);


return
