function [result ok p] = invpd(A)
% Invert a positive definite matrix, checking to make sure it is
% positive definite.  

%
% Greg Duffee
% October 2005
%

[thismat p] = chol(A);
if (p == 0)
    ok = 1; 
    cholmat = thismat';
    inv_chol = inv(cholmat); 
    result = inv_chol' * inv_chol;
else
    ok = 0;
    result = []; 
end

return

