% Greg Duffee
%
% Table 7.

%=======================================================================

clear
close all

%=======================================================================

% file names

cycleFile = char('..\excelFiles\cycleActivity_Q_Measures.xls');
quarterFile = char('..\excelFiles\quarterlydata.xls'); 

cyclePage = char('quarterlyData'); 

%=======================================================================
%
% load data
%
%=======================================================================

longBondExcessReturn = xlsread(quarterFile, cyclePage, 'X30:X264');
stockExcessReturn = xlsread(quarterFile, cyclePage, 'Y30:Y264'); 

someGrowthData = xlsread(cycleFile, cyclePage, 'G32:I266'); 

contempCgrowth = someGrowthData(:,1);
leadCgrowth = [someGrowthData(2:end,1); NaN];

contempIPgrowth = someGrowthData(:,3);
leadIPgrowth = [someGrowthData(2:end,3); NaN];

CPIinflation = xlsread(quarterFile, cyclePage, 'K30:K264');

%====================================================
%
% Correlations
%
%====================================================

dataMatrix = [longBondExcessReturn stockExcessReturn contempCgrowth ...
             leadCgrowth contempIPgrowth leadIPgrowth ...
             CPIinflation];



corrMatrix = corr(dataMatrix, 'rows', 'pairwise'); 

fprintf(1, 'Correlation matrix, pairwise available data\n'); 
fprintf(1, '-------------------------------------------\n'); 
for i = 1:size(corrMatrix,1)
  for j = 1:size(corrMatrix,2)
    fprintf(1, ' %8.2f', corrMatrix(i,j));
  end
  fprintf(1, '\n'); 
end



