% Greg Duffee
%
% Table 8.

%=======================================================================

clear
close all

%=======================================================================

% file names

cycleFile = char('..\excelFiles\cycleActivity_Q_Measures.xls');
quarterFile = char('..\excelFiles\quarterlydata.xls'); 

cyclePage = char('quarterlyData'); 

%=======================================================================
%
% load data
%
%=======================================================================

longBondExcessReturn = xlsread(quarterFile, cyclePage, 'X30:X264');
stockExcessReturn = xlsread(quarterFile, cyclePage, 'Y30:Y264'); 

someGrowthData = xlsread(cycleFile, cyclePage, 'G32:I266'); 

contempCgrowth = someGrowthData(:,1);

%====================================================
%
% CAPM and c-CAPM regressions.
%
%====================================================

neweyWestLags = 2; 

sample1952Q2_2010Q4 = (1:235)';
sample1952Q2_1980Q4 = (1:115)';
sample1981Q1_2010Q4 = (116:235)';
sample1986Q1_2007Q4 = (136:223)';


fprintf(1, '\n'); 

for i = 1:4
  if (i==1) thisSample = sample1952Q2_2010Q4; end;
  if (i==2) thisSample = sample1952Q2_1980Q4; end;
  if (i==3) thisSample = sample1981Q1_2010Q4; end;
  if (i==4) thisSample = sample1986Q1_2007Q4; end;
  
  T = length(thisSample);
  
  yvec = 100*longBondExcessReturn(thisSample);
  xmat1 = ones(T,1);
  xmat2 = [ones(T,1) 100*contempCgrowth(thisSample)];
  xmat3 = [ones(T,1) 100*stockExcessReturn(thisSample)];

  regResults1 = nwest(yvec, xmat1, neweyWestLags); 
  regResults2 = nwest(yvec, xmat2, neweyWestLags); 
  regResults3 = nwest(yvec, xmat3, neweyWestLags); 

  fprintf(1, '\n'); 
  if (i==1) fprintf(1, '1952Q2 through 2010Q4\n'); end;
  if (i==2) fprintf(1, '1952Q2 through 1980Q4\n'); end;
  if (i==3) fprintf(1, '1981Q1 through 2010Q4\n'); end;
  if (i==4) fprintf(1, '1986Q1 through 2007Q4\n'); end;
  
  fprintf(1, '\n'); 
  fprintf(1, 'Constant  c-growth   stock return\n'); 
  fprintf(1, '---------------------------------\n'); 
  fprintf(1, '%7.2f \n', regResults1.beta(1)); 
  fprintf(1, '(%6.2f) \n', regResults1.tstat(1)); 
  fprintf(1, '%7.2f   %7.2f \n', regResults2.beta(1:2)); 
  fprintf(1, '(%6.2f)  (%6.2f) \n', regResults2.tstat(1:2)); 
  fprintf(1, '%7.2f           %7.2f \n', regResults3.beta(1:2)); 
  fprintf(1, '(%6.2f)          (%6.2f) \n', regResults3.tstat(1:2)); 
end

