function Bmat = createBigB(rho1, K, maxMat)
% Create entire set of B functions for maturities from one to maxMat.   
%
% Greg Duffee
% September 2009
%

n = length(rho1); 

Bmat = zeros(maxMat, n); 

% thisB and newB are for log prices.  NewB is transformed when
% saving to the matrix.

thisB = zeros(n, 1); 
for i = 1:maxMat
  newB = K'*thisB - rho1; 
  Bmat(i,:) = -newB'/i;
  thisB = newB; 
end
  
return

